import type { IButtonControlOption } from './baseControl/buttonControl';
import ButtonControl from './baseControl/buttonControl';
export interface IExportImageControlOption extends IButtonControlOption {
    imageType: 'png' | 'jpeg';
    onExport: (base64: string) => void;
}
export { ExportImage };
export default class ExportImage extends ButtonControl<IExportImageControlOption> {
    onAdd(): HTMLElement;
    getDefault(option?: Partial<IExportImageControlOption>): IExportImageControlOption;
    getImage(): Promise<string>;
    protected onClick: () => Promise<void>;
    /**
     * 将多张图片合并为一张图片
     * @protected
     * @param base64List
     */
    protected mergeImage: (...base64List: string[]) => Promise<string>;
}
