import type { IButtonControlOption } from './baseControl/buttonControl';
import ButtonControl from './baseControl/buttonControl';
export interface IFullscreenControlOption extends IButtonControlOption {
    exitBtnText: IButtonControlOption['btnText'];
    exitBtnIcon: IButtonControlOption['btnIcon'];
    exitTitle: IButtonControlOption['title'];
}
export { Fullscreen };
export default class Fullscreen extends ButtonControl<IFullscreenControlOption> {
    protected isFullscreen: boolean;
    protected mapContainer: HTMLElement;
    constructor(option?: Partial<IFullscreenControlOption>);
    setOptions(newOptions: Partial<IFullscreenControlOption>): void;
    onAdd(): HTMLElement;
    onRemove(): void;
    getDefault(option?: Partial<IFullscreenControlOption>): IFullscreenControlOption;
    toggleFullscreen: () => Promise<void>;
    protected onClick: () => void;
    protected onFullscreenChange: () => void;
}
