import type { Point } from '@ramap/ra-core';
import type { IButtonControlOption } from './baseControl/buttonControl';
import ButtonControl from './baseControl/buttonControl';
export interface IGeoLocateOption extends IButtonControlOption {
    transform: (position: Point) => Point | Promise<Point>;
}
export { GeoLocate };
export default class GeoLocate extends ButtonControl<IGeoLocateOption> {
    constructor(option?: Partial<IGeoLocateOption>);
    getDefault(option?: Partial<IGeoLocateOption>): IGeoLocateOption;
    onAdd(): HTMLElement;
    /**
     * 通过浏览器 API 获取当前所在经纬度
     */
    getGeoLocation: () => Promise<Point>;
    onClick: () => Promise<void>;
}
