import { DOM } from '@ramap/ra-utils';
// import logo from '../assets/logo.png';

import { Control, PositionType } from "./baseControl";
export { Logo };
export default class Logo extends Control {
  getDefault() {
    return {
      position: PositionType.BOTTOMLEFT,
      name: 'logo',
      href: '',
      img: ''
    };
  }
  onAdd() {
    const container = DOM.create('div', 'ra-control-logo');
    this.setLogoContent(container);
    return container;
  }
  onRemove() {
    return null;
  }
  setOptions(option) {
    super.setOptions(option);
    if (this.checkUpdateOption(option, ['img', 'href'])) {
      DOM.clearChildren(this.container);
      this.setLogoContent(this.container);
    }
  }
  setLogoContent(container) {
    const {
      href
    } = this.controlOption;
    // const imgDOM = DOM.create('img') as HTMLElement;
    // imgDOM.setAttribute('src', img);
    // imgDOM.setAttribute('aria-label', 'ramap logo');
    // DOM.setUnDraggable(imgDOM);

    const anchorDOM = DOM.create('a', 'ra-control-logo-link');
    anchorDOM.target = '_blank';
    if (href) anchorDOM.href = href;
    anchorDOM.rel = 'noopener nofollow';
    anchorDOM.innerHTML = 'RaMap @v2';
    anchorDOM.setAttribute('rel', 'noopener nofollow');
    container.appendChild(anchorDOM);

    /*     if (href) {
      const anchorDOM = DOM.create('a', 'ra-control-logo-link') as HTMLLinkElement;
      anchorDOM.target = '_blank';
      anchorDOM.href = href;
      anchorDOM.rel = 'noopener nofollow';
      anchorDOM.setAttribute('rel', 'noopener nofollow');
      anchorDOM.appendChild(imgDOM);
      container.appendChild(anchorDOM);
    } else {
      container.appendChild(imgDOM);
    } */
  }
}