import type { IControlOption } from './baseControl';
import { Control, PositionType } from './baseControl';
export interface IScaleControlOption extends IControlOption {
    lockWidth: boolean;
    maxWidth: number;
    metric: boolean;
    updateWhenIdle: boolean;
    imperial: boolean;
}
export { Scale };
export default class Scale extends Control<IScaleControlOption> {
    private mScale;
    private iScale;
    getDefault(option: Partial<IScaleControlOption>): {
        name: string;
        position: PositionType;
        maxWidth: number;
        metric: boolean;
        updateWhenIdle: boolean;
        imperial: boolean;
        lockWidth: boolean;
        className?: string | undefined;
        style?: string | undefined;
    };
    onAdd(): HTMLElement;
    onRemove(): void;
    setOptions(newOption: Partial<IScaleControlOption>): void;
    update: () => void;
    updateScales(maxMeters: number): void;
    private resetScaleLines;
    private updateScale;
    private getRoundNum;
    private updateMetric;
    private updateImperial;
}
