import { PositionType } from '@ramap/ra-core';
import { DOM } from '@ramap/ra-utils';
import type { IControlOption } from './baseControl';
import { Control } from './baseControl';
export interface IZoomControlOption extends IControlOption {
    zoomInText: DOM.ELType | string;
    zoomInTitle: string;
    zoomOutText: DOM.ELType | string;
    zoomOutTitle: string;
    showZoom: boolean;
}
export { Zoom };
export default class Zoom extends Control<IZoomControlOption> {
    private disabled;
    private zoomInButton;
    private zoomOutButton;
    private zoomNumDiv;
    getDefault(option: Partial<IZoomControlOption>): {
        position: PositionType;
        name: string;
        zoomInText: SVGSVGElement;
        zoomInTitle: string;
        zoomOutText: SVGSVGElement;
        zoomOutTitle: string;
        showZoom: boolean;
        className?: string | undefined;
        style?: string | undefined;
    };
    setOptions(newOptions: Partial<IZoomControlOption>): void;
    onAdd(): HTMLElement;
    onRemove(): void;
    disable(): this;
    enable(): this;
    zoomIn: () => void;
    zoomOut: () => void;
    private resetButtonGroup;
    private createButton;
    private updateDisabled;
}
