import type { PopperPlacement, PopperTrigger } from '../../utils/popper';
import { Popper } from '../../utils/popper';
import type { IButtonControlOption } from './buttonControl';
import ButtonControl from './buttonControl';
export { PopperControl };
export interface IPopperControlOption extends IButtonControlOption {
    popperPlacement: PopperPlacement;
    popperClassName?: string;
    popperTrigger: PopperTrigger;
}
export default class PopperControl<O extends IPopperControlOption = IPopperControlOption> extends ButtonControl<O> {
    /**
     * 气泡实例
     * @protected
     */
    protected popper: Popper;
    getPopper(): Popper;
    hide(): void;
    /**
     * 获取默认配置
     * @param option
     */
    getDefault(option?: Partial<O>): O;
    onAdd(): HTMLElement;
    onRemove(): void;
    initPopper(): Popper;
    setOptions(option: Partial<O>): void;
}
