import type { ILayer } from '@ramap/ra-core';
import type { ControlOptionItem, ISelectControlOption } from './baseControl/selectControl';
import SelectControl from './baseControl/selectControl';
export type LayerSwitchItem = {
    layer: ILayer;
    name?: string;
    img?: string;
};
export interface ILayerSwitchOption extends ISelectControlOption {
    layers: Array<ILayer | string | LayerSwitchItem>;
    multiple: boolean;
}
export { LayerSwitch };
export default class LayerSwitch extends SelectControl<ILayerSwitchOption> {
    protected get layers(): ILayer[];
    getDefault(option?: Partial<ILayerSwitchOption>): ILayerSwitchOption;
    getLayerVisible(): string[];
    getLayerOptions(): ControlOptionItem[];
    setOptions(option: Partial<ILayerSwitchOption>): void;
    private handleSingleSelection;
    onAdd(): HTMLElement;
    onRemove(): void;
    protected onLayerChange: () => void;
    protected onLayerVisibleChane: () => void;
    protected onSelectChange: () => void;
    protected getIsMultiple(): boolean;
}
