"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Marker: true,
  MarkerLayer: true,
  ExportImage: true,
  Fullscreen: true,
  GeoLocate: true,
  LayerSwitch: true,
  Logo: true,
  MapTheme: true,
  MouseLocation: true,
  Scale: true,
  Swipe: true,
  Zoom: true,
  LayerPopup: true,
  Popup: true
};
Object.defineProperty(exports, "ExportImage", {
  enumerable: true,
  get: function () {
    return _exportImage.ExportImage;
  }
});
Object.defineProperty(exports, "Fullscreen", {
  enumerable: true,
  get: function () {
    return _fullscreen.Fullscreen;
  }
});
Object.defineProperty(exports, "GeoLocate", {
  enumerable: true,
  get: function () {
    return _geoLocate.GeoLocate;
  }
});
Object.defineProperty(exports, "LayerPopup", {
  enumerable: true,
  get: function () {
    return _layerPopup.LayerPopup;
  }
});
Object.defineProperty(exports, "LayerSwitch", {
  enumerable: true,
  get: function () {
    return _layerSwitch.LayerSwitch;
  }
});
Object.defineProperty(exports, "Logo", {
  enumerable: true,
  get: function () {
    return _logo.Logo;
  }
});
Object.defineProperty(exports, "MapTheme", {
  enumerable: true,
  get: function () {
    return _mapTheme.MapTheme;
  }
});
Object.defineProperty(exports, "Marker", {
  enumerable: true,
  get: function () {
    return _marker.default;
  }
});
Object.defineProperty(exports, "MarkerLayer", {
  enumerable: true,
  get: function () {
    return _markerLayer.default;
  }
});
Object.defineProperty(exports, "MouseLocation", {
  enumerable: true,
  get: function () {
    return _mouseLocation.MouseLocation;
  }
});
Object.defineProperty(exports, "Popup", {
  enumerable: true,
  get: function () {
    return _popup.Popup;
  }
});
Object.defineProperty(exports, "Scale", {
  enumerable: true,
  get: function () {
    return _scale.Scale;
  }
});
Object.defineProperty(exports, "Swipe", {
  enumerable: true,
  get: function () {
    return _swipe.Swipe;
  }
});
Object.defineProperty(exports, "Zoom", {
  enumerable: true,
  get: function () {
    return _zoom.Zoom;
  }
});
var _marker = _interopRequireDefault(require("./marker"));
var _markerLayer = _interopRequireDefault(require("./marker-layer"));
require("./assets/iconfont/iconfont.js");
var _baseControl = require("./control/baseControl");
Object.keys(_baseControl).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _baseControl[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _baseControl[key];
    }
  });
});
var _exportImage = require("./control/exportImage");
var _fullscreen = require("./control/fullscreen");
var _geoLocate = require("./control/geoLocate");
var _layerSwitch = require("./control/layerSwitch");
var _logo = require("./control/logo");
var _mapTheme = require("./control/mapTheme");
var _mouseLocation = require("./control/mouseLocation");
var _scale = require("./control/scale");
var _swipe = require("./control/swipe");
var _zoom = require("./control/zoom");
var _interface = require("./interface");
Object.keys(_interface).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _interface[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _interface[key];
    }
  });
});
var _layerPopup = require("./popup/layerPopup");
var _popup = require("./popup/popup");
// 引入样式
function loadStyles(css, doc) {
  var isMiniAli = typeof my !== 'undefined' && !!my && typeof my.showToast === 'function' && my.isFRM !== true;
  var isWeChatMiniProgram = typeof wx !== 'undefined' && wx !== null && (typeof wx.request !== 'undefined' || typeof wx.miniProgram !== 'undefined');
  if (isMiniAli || isWeChatMiniProgram) {
    return;
  }
  if (!doc) doc = document;
  if (!doc) {
    return;
  }
  var head = doc.head || doc.getElementsByTagName('head')[0];
  if (!head) {
    head = doc.createElement('head');
    var body = doc.body || doc.getElementsByTagName('body')[0];
    if (body) {
      body.parentNode.insertBefore(head, body);
    } else {
      doc.documentElement.appendChild(head);
    }
  }
  var style = doc.createElement('style');
  style.type = 'text/css';
  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(doc.createTextNode(css));
  }
  head.appendChild(style);
  return style;
}
loadStyles(`.ra-marker-container {
  position: absolute;
  width: 100%;
  height: 100%;
  overflow: hidden;
}
.ra-marker {
  position: absolute !important;
  top: 0;
  left: 0;
  z-index: 5;
  cursor: pointer;
}
.ra-marker-cluster {
  width: 40px;
  height: 40px;
  background-color: rgba(181, 226, 140, 0.6);
  background-clip: padding-box;
  border-radius: 20px;
}
.ra-marker-cluster div {
  width: 30px;
  height: 30px;
  margin-top: 5px;
  margin-left: 5px;
  font:
    12px 'Helvetica Neue',
    Arial,
    Helvetica,
    sans-serif;
  text-align: center;
  background-color: rgba(110, 204, 57, 0.6);
  border-radius: 15px;
}
.ra-marker-cluster span {
  line-height: 30px;
}
.ra-touch .ra-control-attribution,
.ra-touch .ra-control-layers,
.ra-touch .ra-bar {
  box-shadow: none;
}
.ra-touch .ra-control-layers,
.ra-touch .ra-bar {
  background-clip: padding-box;
  border: 2px solid rgba(0, 0, 0, 0.2);
}
.mapboxgl-ctrl-logo,
.amap-logo {
  display: none !important;
}
.ra-select-box {
  border: 3px dashed gray;
  border-radius: 2px;
  position: absolute;
  z-index: 999;
  box-sizing: border-box;
}
.ra-control-container {
  font:
    12px/1.5 'Helvetica Neue',
    Arial,
    Helvetica,
    sans-serif;
}
.ra-control-container .ra-control {
  position: relative;
  z-index: 999;
  float: left;
  clear: both;
  color: #595959;
  font-size: 12px;
  pointer-events: visiblePainted;
  /* IE 9-10 doesn't have auto */
  pointer-events: auto;
}
.ra-control-container .ra-control.ra-control--hide {
  display: none;
}
.ra-control-container .ra-top {
  top: 0;
  display: flex;
  position: absolute;
  z-index: 999;
  pointer-events: none;
}
.ra-control-container .ra-top .ra-control:not(.ra-control--hide) {
  margin-top: 8px;
}
.ra-control-container .ra-right {
  right: 0;
  display: flex;
  position: absolute;
  z-index: 999;
  pointer-events: none;
}
.ra-control-container .ra-right .ra-control:not(.ra-control--hide) {
  margin-right: 8px;
}
.ra-control-container .ra-bottom {
  bottom: 0;
  display: flex;
  position: absolute;
  z-index: 999;
  pointer-events: none;
}
.ra-control-container .ra-bottom .ra-control:not(.ra-control--hide) {
  margin-bottom: 8px;
}
.ra-control-container .ra-left {
  left: 0;
  display: flex;
  position: absolute;
  z-index: 999;
  pointer-events: none;
}
.ra-control-container .ra-left .ra-control:not(.ra-control--hide) {
  margin-left: 8px;
}
.ra-control-container .ra-center {
  position: absolute;
  display: flex;
  justify-content: center;
}
.ra-control-container .ra-center.ra-top,
.ra-control-container .ra-center.ra-bottom {
  width: 100%;
}
.ra-control-container .ra-center.ra-left,
.ra-control-container .ra-center.ra-right {
  height: 100%;
}
.ra-control-container .ra-center .ra-control {
  margin-right: 8px;
  margin-bottom: 8px;
}
.ra-control-container .ra-row {
  flex-direction: row;
}
.ra-control-container .ra-row.ra-top {
  align-items: flex-start;
}
.ra-control-container .ra-row.ra-bottom {
  align-items: flex-end;
}
.ra-control-container .ra-column {
  flex-direction: column;
}
.ra-control-container .ra-column.ra-left {
  align-items: flex-start;
}
.ra-control-container .ra-column.ra-right {
  align-items: flex-end;
}
.ra-button-control {
  min-width: 28px;
  height: 28px;
  background-color: #fff;
  border-width: 0;
  border-radius: 2px;
  outline: 0;
  cursor: pointer;
  transition: all 0.2s;
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 0 6px;
  box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
  line-height: 16px;
}
.ra-button-control .ra-iconfont {
  fill: #595959;
  color: #595959;
  width: 16px;
  height: 16px;
}
.ra-button-control.ra-button-control--row {
  padding: 0 16px 0 13px;
}
.ra-button-control.ra-button-control--row * + .ra-button-control__text {
  margin-left: 8px;
}
.ra-button-control.ra-button-control--column {
  height: 44px;
  flex-direction: column;
}
.ra-button-control.ra-button-control--column .ra-iconfont {
  margin-top: 3px;
}
.ra-button-control.ra-button-control--column .ra-button-control__text {
  margin-top: 3px;
  font-size: 10px;
  -webkit-transform: scale(0.83333);
          transform: scale(0.83333);
}
.ra-button-control:not(:disabled):hover {
  background-color: #f3f3f3;
}
.ra-button-control:not(:disabled):active {
  background-color: #f3f3f3;
}
.ra-button-control:disabled {
  background-color: #fafafa;
  color: #bdbdbd;
  cursor: not-allowed;
}
.ra-button-control:disabled .ra-iconfont {
  fill: #bdbdbd;
  color: #bdbdbd;
}
.ra-button-control:disabled:hover {
  background-color: #fafafa;
}
.ra-button-control:disabled:active {
  background-color: #fafafa;
}
.ra-popper {
  position: absolute;
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 5;
  color: #595959;
}
.ra-popper.ra-popper-hide {
  display: none;
}
.ra-popper .ra-popper-content {
  min-height: 28px;
  background: #fff;
  border-radius: 2px;
  box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
}
.ra-popper .ra-popper-arrow {
  width: 0;
  height: 0;
  border-width: 4px;
  border-style: solid;
  border-top-color: transparent;
  border-bottom-color: transparent;
  border-left-color: transparent;
  border-right-color: transparent;
  box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
}
.ra-popper.ra-popper-left {
  flex-direction: row;
}
.ra-popper.ra-popper-left .ra-popper-arrow {
  border-left-color: #fff;
  margin: 10px 0;
}
.ra-popper.ra-popper-right {
  flex-direction: row-reverse;
}
.ra-popper.ra-popper-right .ra-popper-arrow {
  border-right-color: #fff;
  margin: 10px 0;
}
.ra-popper.ra-popper-top {
  flex-direction: column;
}
.ra-popper.ra-popper-top .ra-popper-arrow {
  border-top-color: #fff;
  margin: 0 10px;
}
.ra-popper.ra-popper-bottom {
  flex-direction: column-reverse;
}
.ra-popper.ra-popper-bottom .ra-popper-arrow {
  border-bottom-color: #fff;
  margin: 0 10px;
}
.ra-popper.ra-popper-start {
  align-items: flex-start;
}
.ra-popper.ra-popper-end {
  align-items: flex-end;
}
.ra-select-control--normal {
  padding: 4px 0;
}
.ra-select-control--normal .ra-select-control-item {
  display: flex;
  align-items: center;
  height: 24px;
  padding: 0 16px;
  font-size: 12px;
  line-height: 24px;
}
.ra-select-control--normal .ra-select-control-item > * + * {
  margin-left: 6px;
}
.ra-select-control--normal .ra-select-control-item input[type='checkbox'] {
  width: 14px;
  height: 14px;
}
.ra-select-control--normal .ra-select-control-item:hover {
  background-color: #f3f3f3;
}
.ra-select-control--image {
  display: flex;
  flex-wrap: wrap;
  align-items: flex-start;
  box-sizing: content-box;
  max-width: 460px;
  max-height: 400px;
  margin: 12px 0 0 12px;
  overflow-x: hidden;
  overflow-y: auto;
}
.ra-select-control--image .ra-select-control-item {
  position: relative;
  display: flex;
  flex: 0 0 calc((100% - (12px + 9px) * 2) / 3);
  flex-direction: column;
  justify-content: center;
  box-sizing: content-box;
  margin-right: 12px;
  margin-bottom: 12px;
  overflow: hidden;
  font-size: 12px;
  border: 1px solid #fff;
  border-radius: 2px;
}
.ra-select-control--image .ra-select-control-item img {
  width: 100%;
  height: 80px;
}
.ra-select-control--image .ra-select-control-item input[type='checkbox'] {
  position: absolute;
  top: 0;
  right: 0;
}
.ra-select-control--image .ra-select-control-item .ra-select-control-item-row {
  display: flex;
  align-items: center;
  justify-content: center;
  line-height: 26px;
}
.ra-select-control--image .ra-select-control-item .ra-select-control-item-row > * + * {
  margin-left: 8px;
}
.ra-select-control--image .ra-select-control-item.ra-select-control-item-active {
  border-color: #0370fe;
}
.ra-select-control-item {
  cursor: pointer;
}
.ra-select-control-item input[type='checkbox'] {
  margin: 0;
  cursor: pointer;
}
.ra-select-control--multiple .ra-select-control-item:hover {
  background-color: transparent;
}
.ra-control-logo {
  width: 89px;
  height: 16px;
  -webkit-user-select: none;
     -moz-user-select: none;
      -ms-user-select: none;
          user-select: none;
}
.ra-control-logo img {
  height: 100%;
  width: 100%;
}
.ra-control-logo .ra-control-logo-link {
  display: block;
  cursor: pointer;
  color: #fff;
  letter-spacing: 2px;
  text-shadow:
    -1px -1px 0 #1677ff,
    1px -1px 0 #1677ff,
    -1px 1px 0 #1677ff,
    1px 1px 0 #1677ff;
}
.ra-control-logo .ra-control-logo-link img {
  cursor: pointer;
}
.ra-control-mouse-location {
  background-color: #fff;
  border-radius: 2px;
  box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
  padding: 2px 4px;
  min-width: 130px;
}
.ra-control-zoom {
  overflow: hidden;
  border-radius: 2px;
  box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
}
.ra-control-zoom .ra-button-control {
  font-size: 16px;
  border-bottom: 1px solid #f0f0f0;
  border-radius: 0;
  box-shadow: 0 0 0;
}
.ra-control-zoom .ra-button-control .ra-iconfont {
  width: 14px;
  height: 14px;
}
.ra-control-zoom .ra-button-control:last-child {
  border-bottom: 0;
}
.ra-control-zoom .ra-control-zoom__number {
  color: #595959;
  padding: 0;
}
.ra-control-zoom .ra-control-zoom__number:hover {
  background-color: #fff;
}
.ra-control-scale {
  display: flex;
  flex-direction: column;
}
.ra-control-scale .ra-control-scale-line {
  box-sizing: border-box;
  padding: 2px 5px 1px;
  overflow: hidden;
  color: #595959;
  font-size: 10px;
  line-height: 1.1;
  white-space: nowrap;
  background: #fff;
  border: 2px solid #000;
  border-top: 0;
  transition: width 0.1s;
}
.ra-control-scale .ra-control-scale-line + .ra-control-scale .ra-control-scale-line {
  margin-top: -2px;
  border-top: 2px solid #777;
  border-bottom: none;
}
.ra-right .ra-control-scale {
  display: flex;
  align-items: flex-end;
}
.ra-right .ra-control-scale .ra-control-scale-line {
  text-align: right;
}
.ra-popup {
  position: absolute;
  top: 0;
  left: 0;
  z-index: 5;
  display: flex;
  will-change: transform;
  pointer-events: none;
}
.ra-popup.ra-popup-hide {
  display: none;
}
.ra-popup .ra-popup-content {
  position: relative;
  padding: 16px;
  font-size: 14px;
  background: #fff;
  border-radius: 3px;
  box-shadow: 0 1px 2px rgba(0, 0, 0, 0.1);
}
.ra-popup .ra-popup-content .ra-popup-content__title {
  margin-bottom: 8px;
  font-weight: bold;
}
.ra-popup .ra-popup-content .ra-popup-close-button,
.ra-popup .ra-popup-content .ra-popup-content__title,
.ra-popup .ra-popup-content .ra-popup-content__panel {
  white-space: normal;
  -webkit-user-select: text;
     -moz-user-select: text;
      -ms-user-select: text;
          user-select: text;
  pointer-events: initial;
}
.ra-popup .ra-popup-content .ra-popup-close-button {
  position: absolute;
  top: 0;
  right: 0;
  width: 18px;
  height: 18px;
  padding: 0;
  font-size: 14px;
  line-height: 18px;
  text-align: center;
  background-color: transparent;
  border: 0;
  border-radius: 0 3px 0 0;
  cursor: pointer;
}
.ra-popup .ra-popup-tip {
  position: relative;
  z-index: 1;
  width: 0;
  height: 0;
  border: 10px solid transparent;
}
.ra-popup.ra-popup-anchor-bottom,
.ra-popup.ra-popup-anchor-bottom-left,
.ra-popup.ra-popup-anchor-bottom-right {
  flex-direction: column-reverse;
}
.ra-popup.ra-popup-anchor-bottom .ra-popup-tip,
.ra-popup.ra-popup-anchor-bottom-left .ra-popup-tip,
.ra-popup.ra-popup-anchor-bottom-right .ra-popup-tip {
  bottom: 1px;
}
.ra-popup.ra-popup-anchor-top,
.ra-popup.ra-popup-anchor-top-left,
.ra-popup.ra-popup-anchor-top-right {
  flex-direction: column;
}
.ra-popup.ra-popup-anchor-top .ra-popup-tip,
.ra-popup.ra-popup-anchor-top-left .ra-popup-tip,
.ra-popup.ra-popup-anchor-top-right .ra-popup-tip {
  top: 1px;
}
.ra-popup.ra-popup-anchor-left {
  flex-direction: row;
}
.ra-popup.ra-popup-anchor-right {
  flex-direction: row-reverse;
}
.ra-popup-anchor-top .ra-popup-tip {
  position: relative;
  align-self: center;
  border-top: none;
  border-bottom-color: #fff;
}
.ra-popup-anchor-top-left .ra-popup-tip {
  align-self: flex-start;
  border-top: none;
  border-bottom-color: #fff;
  border-left: none;
}
.ra-popup-anchor-top-right .ra-popup-tip {
  align-self: flex-end;
  border-top: none;
  border-right: none;
  border-bottom-color: #fff;
}
.ra-popup-anchor-bottom .ra-popup-tip {
  align-self: center;
  border-top-color: #fff;
  border-bottom: none;
}
.ra-popup-anchor-bottom-left .ra-popup-tip {
  align-self: flex-start;
  border-top-color: #fff;
  border-bottom: none;
  border-left: none;
}
.ra-popup-anchor-bottom-right .ra-popup-tip {
  align-self: flex-end;
  border-top-color: #fff;
  border-right: none;
  border-bottom: none;
}
.ra-popup-anchor-left .ra-popup-tip {
  align-self: center;
  border-right-color: #fff;
  border-left: none;
}
.ra-popup-anchor-right .ra-popup-tip {
  right: 1px;
  align-self: center;
  border-right: none;
  border-left-color: #fff;
}
.ra-popup-anchor-top-left .ra-popup-content {
  border-top-left-radius: 0;
}
.ra-popup-anchor-top-right .ra-popup-content {
  border-top-right-radius: 0;
}
.ra-popup-anchor-bottom-left .ra-popup-content {
  border-bottom-left-radius: 0;
}
.ra-popup-anchor-bottom-right .ra-popup-content {
  border-bottom-right-radius: 0;
}
.ra-popup-track-pointer {
  display: none;
}
.ra-popup-track-pointer * {
  -webkit-user-select: none;
     -moz-user-select: none;
      -ms-user-select: none;
          user-select: none;
  pointer-events: none;
}
.ra-map:hover .ra-popup-track-pointer {
  display: flex;
}
.ra-map:active .ra-popup-track-pointer {
  display: none;
}
.ra-layer-popup__row {
  font-size: 12px;
}
.ra-layer-popup__row + .ra-layer-popup__row {
  margin-top: 4px;
}
.ra-control-swipe {
  position: absolute;
  top: 50%;
  left: 50%;
  z-index: 6;
  -webkit-transform: translate(-50%, -50%);
          transform: translate(-50%, -50%);
  touch-action: none;
}
.ra-control-swipe_hide {
  display: none;
}
.ra-control-swipe:before {
  position: absolute;
  top: -5000px;
  bottom: -5000px;
  left: 50%;
  z-index: -1;
  width: 4px;
  background: #fff;
  -webkit-transform: translate(-2px, 0);
          transform: translate(-2px, 0);
  content: '';
}
.ra-control-swipe.horizontal:before {
  top: 50%;
  right: -5000px;
  bottom: auto;
  left: -5000px;
  width: auto;
  height: 4px;
}
.ra-control-swipe__button {
  display: block;
  width: 28px;
  height: 28px;
  margin: 0;
  padding: 0;
  color: #595959;
  font-weight: bold;
  font-size: inherit;
  text-align: center;
  text-decoration: none;
  background-color: #fff;
  border: none;
  border-radius: 2px;
  outline: none;
}
.ra-control-swipe,
.ra-control-swipe__button {
  cursor: ew-resize;
}
.ra-control-swipe.horizontal,
.ra-control-swipe.horizontal button {
  cursor: ns-resize;
}
.ra-control-swipe:after,
.ra-control-swipe__button:before,
.ra-control-swipe__button:after {
  position: absolute;
  top: 25%;
  bottom: 25%;
  left: 50%;
  width: 2px;
  background: currentColor;
  -webkit-transform: translate(-1px, 0);
          transform: translate(-1px, 0);
  content: '';
}
.ra-control-swipe__button:after {
  -webkit-transform: translateX(4px);
          transform: translateX(4px);
}
.ra-control-swipe__button:before {
  -webkit-transform: translateX(-6px);
          transform: translateX(-6px);
}
`); // import './css/index.less';